#include <stdlib.h>  // exit, calloc, rand
#include <strings.h>  // memset
#include <stdint.h>
#include <string.h>
#include <iostream>

// #include "hashlib.hpp"
using namespace std;
#include "hashlib.cpp"

using namespace std;

typedef string t_string;
/*@/// callback */
typedef t_32u (*tf_calc) (t_32u x);

  tr_gen_opt my_gen_opt;
  tf_calc f_calc;
  t_string n_method;

/*@/// t_32u calc_*(t_32u x) */
/*@/// t_32u calc_rev(t_32u x) */
t_32u calc_rev(t_32u x) {

  return ror_32(x-my_gen_opt.salt, my_gen_opt.a_shr) * my_gen_opt.a_mask;
  }
/*@\\\+F4DA*/

/*@/// t_32u calc_and(t_32u x) */
t_32u calc_and(t_32u x) {

  return x & my_gen_opt.a_mask;
  }
/*@\\\+B1C8*/
/*@/// t_32u calc_shr(t_32u x) */
t_32u calc_shr(t_32u x) {

  return x >> my_gen_opt.a_shr;
  }
/*@\\\+C122*/
/*@/// t_32u calc_rol(t_32u x) */
t_32u calc_rol(t_32u x) {

  return rol_32(x, my_gen_opt.salt) & my_gen_opt.a_mask;
  }
/*@\\\000000030A+2CEA*/
/*@/// t_32u calc_rol_xor(t_32u x) */
t_32u calc_rol_xor(t_32u x) {

  return (rol_32(x, my_gen_opt.salt) ^ x) & my_gen_opt.a_mask;
  }
/*@\\\000000030A+8582*/
/*@/// t_32u calc_rol_add(t_32u x) */
t_32u calc_rol_add(t_32u x) {

  return (rol_32(x, my_gen_opt.salt) + x) & my_gen_opt.a_mask;
  }
/*@\\\0000000310+82EA*/
/*@/// t_32u calc_rol_sub(t_32u x) */
t_32u calc_rol_sub(t_32u x) {

  return (rol_32(x, my_gen_opt.salt) - x) & my_gen_opt.a_mask;
  }
/*@\\\0000000311+707B*/
/*@/// t_32u calc_mul(t_32u x) */
t_32u calc_mul(t_32u x) {

  return (t_32u)(x * my_gen_opt.salt) >> my_gen_opt.a_shr;
  }
/*@\\\0000000301+DE73*/

/*@/// t_32u calc_tab(t_32u a, t_32u b) */
t_32u calc_tab(t_32u a, t_32u b) {

  t_32u s,t;
  t_32u res;

  if (my_gen_opt.tabb_len == 0)
    res = a;  // OPTIMIZE: do not calculate b
  else if (my_gen_opt.tabb_len == 1)
    return a ^ my_gen_opt.p_tabb[0];
  // OPTIMIZE: do not calculate b, tabb[0]=const!
  else if (my_gen_opt.scramble_len == 0) {
    if (b>=my_gen_opt.tabb_len)
      break_point();
    t = my_gen_opt.p_tabb[b];
    if (t>my_gen_opt.tabb_max)
      break_point();
    res = a ^ t;
    }
  else {
    if (my_gen_opt.tabb_len < 256)
      break_point();
    if (b >= my_gen_opt.tabb_len)
      break_point();
    t = my_gen_opt.p_tabb[b];
    if (t > my_gen_opt.tabb_max)
      break_point();
    if (t >= my_gen_opt.scramble_len)
      break_point();
    s = my_gen_opt.p_scramble[t];
    if (s > my_gen_opt.scramble_max)
      break_point();
    res = a ^ s;
    }
  if (res > my_gen_opt.hash_gen_max)
    break_point();
  return res;
  }
/*@\\\0000000601+FE10*/

/*@/// t_32u calc_ab_1(t_32u x) */
t_32u calc_ab_1(t_32u x) {

  t_32u a,b;

  a = (x << my_gen_opt.a_shl) >> my_gen_opt.a_shr;
  b = (x >> my_gen_opt.b_shr) & my_gen_opt.b_mask;
  return calc_tab(a,b);
  }
/*@\\\0000000703+D4F0*/
/*@/// t_32u calc_ab_2(t_32u x) */
t_32u calc_ab_2(t_32u x) {

  t_32u a,b;

  a = (x >> my_gen_opt.a_shr) & my_gen_opt.a_mask;
  b = (x << my_gen_opt.b_shl) >> my_gen_opt.b_shr;
  return calc_tab(a,b);
  }
/*@\\\0000000301+C159*/
/*@/// t_32u calc_ab_3(t_32u x) */
t_32u calc_ab_3(t_32u x) {

  t_32u a,b;

  x = x + my_gen_opt.salt;
  if (my_gen_opt.do_xor_shr_16)
    x = x ^ (x >> 16);
  if (my_gen_opt.do_add_shl_8)
    x = x + (x << 8);
  x = x ^ (x >> 4);

  if (my_gen_opt.a_shl == 0)
    a = x >> my_gen_opt.a_shr;
  else
    a = ((x << my_gen_opt.a_shl) + x) >> my_gen_opt.a_shr;

  b = (x >> my_gen_opt.b_shr) & my_gen_opt.b_mask;

  return calc_tab(a,b);
  }
/*@\\\+ADC2*/
/*@/// t_32u calc_ab_x1(t_32u x) */
t_32u calc_ab_x1(t_32u x) {
// 32x32=>32 mul

  t_32u tmp;
  t_32u a,b;

  tmp = x * my_gen_opt.salt;

  a = (tmp >> my_gen_opt.a_shr) & my_gen_opt.a_mask;

  if (my_gen_opt.b_shr == 32)
    b = 0;  // CAN HAPPEN
  else
    b = tmp >> my_gen_opt.b_shr;
  return calc_tab(a,b);
  }
/*@\\\0000000201+FE10*/
/*@/// t_32u calc_ab_x3(t_32u x) */
t_32u calc_ab_x3(t_32u x) {
// 32x32=>64 mul

  t_64u tmp;
  t_32u a,b;

  tmp = (t_64u)(x) * (t_64u)(my_gen_opt.salt);

  a = (t_32u)(tmp >> 32) & my_gen_opt.a_mask;

  if (my_gen_opt.b_shr == 32)
    b = 0;  // CAN HAPPEN
  else
    b = (t_32u)(tmp) >> my_gen_opt.b_shr;
  return calc_tab(a,b);
  }
/*@\\\0000000102+D6E2*/
/*@\\\000000111B+0C67*/
/*@/// void gen_*(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
/*@/// void gen_rev(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
void gen_rev(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) {

  my_gen_opt = opt;
  f_calc = calc_rev;
  n_method = "reversible";
  }
/*@\\\0000000142+0878*/

/*@/// void gen_and(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
void gen_and(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) {

  my_gen_opt = opt;
  f_calc = calc_and;
  n_method = "simple &";
  }
/*@\\\+00F6*/
/*@/// void gen_shr(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
void gen_shr(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) {

  my_gen_opt = opt;
  f_calc = calc_shr;
  n_method = "simple >>";
  }
/*@\\\+E680*/
/*@/// void gen_rol(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
void gen_rol(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) {

  my_gen_opt = opt;
  f_calc = calc_rol;
  n_method = "simple rol";
  }
/*@\\\+2808*/
/*@/// void gen_rol_xor(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
void gen_rol_xor(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) {

  my_gen_opt = opt;
  f_calc = calc_rol_xor;
  n_method = "simple rol ^";
  }
/*@\\\+A060*/
/*@/// void gen_rol_add(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
void gen_rol_add(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) {

  my_gen_opt = opt;
  f_calc = calc_rol_add;
  n_method = "simple rol add";
  }
/*@\\\+F688*/
/*@/// void gen_rol_sub(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
void gen_rol_sub(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) {

  my_gen_opt = opt;
  f_calc = calc_rol_sub;
  n_method = "simple rol sub";
  }
/*@\\\+BA11*/
/*@/// void gen_mul(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
void gen_mul(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) {

  my_gen_opt = opt;
  f_calc = calc_mul;
  n_method = "simple mul";
  }
/*@\\\+BBC9*/

/*@/// void gen_ab_1(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
void gen_ab_1(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) {

  my_gen_opt = opt;
  f_calc = calc_ab_1;
  n_method = "ab 1";
  }
/*@\\\+AB7E*/
/*@/// void gen_ab_2(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
void gen_ab_2(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) {

  my_gen_opt = opt;
  f_calc = calc_ab_2;
  n_method = "ab 2";
  }
/*@\\\+D31F*/
/*@/// void gen_ab_3(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
void gen_ab_3(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) {

  my_gen_opt = opt;
  f_calc = calc_ab_3;
  n_method = "ab 3";
  }
/*@\\\+FAC0*/
/*@/// void gen_ab_x1(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
void gen_ab_x1(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) {

  my_gen_opt = opt;
  f_calc = calc_ab_x1;
  n_method = "ab x1";
  }
/*@\\\+113E*/
/*@/// void gen_ab_x3(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) */
void gen_ab_x3(const tr_gen_opt &opt, UNUSED(t_pointer gen_stuff)) {

  my_gen_opt = opt;
  f_calc = calc_ab_x3;
  n_method = "ab x3";
  }
/*@\\\0000000401+6080*/
/*@\\\0000000F01+0DDD*/
/*@\\\0000000701+BB3D*/

/*@/// void test_key(t_32u key, t_pointer key_stuff, t_pointer step_stuff) */
void test_key(t_32u key, UNUSED(t_pointer key_stuff), UNUSED(t_pointer step_stuff)) {

  if (f_calc(key) != ((to_perfect_hash*)step_stuff)->calc_hash(key)) {
    break_point();
    cout << "\ntest_key failed!\n";
    exit(1);
    }
  }
/*@\\\0000000518+CE44*/

/*@/// int main() */
int main() {

  to_perfect_hash *ph;

//  while (true) {
  for (int loop=0; loop<100; loop++) {
    ph = new to_perfect_hash;
    // ph->calc_opt.near_minimal_factor = 1.2;
    ph->calc_opt.use_scramble = 512;
    ph->calc_opt.fast = true;
    // ph->calc_opt.minimal = true;
    // ph->calc_opt.retry_perfect = 200;

    ph->cb.a_gen[HM_REVERSIBLE] = gen_rev;
    ph->cb.a_gen[HM_SIMPLE_AND] = gen_and;
    ph->cb.a_gen[HM_SIMPLE_SHR] = gen_shr;
    ph->cb.a_gen[HM_SIMPLE_ROL] = gen_rol;
    ph->cb.a_gen[HM_SIMPLE_ROL_XOR] = gen_rol_xor;
    ph->cb.a_gen[HM_SIMPLE_ROL_ADD] = gen_rol_add;
    ph->cb.a_gen[HM_SIMPLE_ROL_SUB] = gen_rol_sub;
    ph->cb.a_gen[HM_SIMPLE_MUL] = gen_mul;
    ph->cb.a_gen[HM_AB_1] = gen_ab_1;
    ph->cb.a_gen[HM_AB_2] = gen_ab_2;
    ph->cb.a_gen[HM_AB_3] = gen_ab_3;
    ph->cb.a_gen[HM_AB_X1] = gen_ab_x1;
    ph->cb.a_gen[HM_AB_X3] = gen_ab_x3;

    t_32u count;
    do {
      count=rand() & 255;
      if (rand() & 1)
        count *= rand() & 255;
    } while (count==0);

    t_32u key=100;
    for (t_32u i=0; i<count; i++) {
      ph->add_key(key,nil);
      key += 1+((t_32u)rand() % (2+i));
      // key += 1+(rand() % (10));
      }

    cout << count;
    if (ph->generate_hash()) {
      ph->do_generate(nil);
      cout << " " << n_method;
      if (! ph->self_test()) {
        cout << "\nself_test failed!\n";
        exit(1);
        }
      ph->step_keys(test_key, (t_pointer)ph);
      cout << " OK\n";
      }
    else {
      cout << "\ngenerate_hash NG\n";
      exit(1);
      }
    delete(ph);
    }
  }
/*@\\\003E001C0B001C10001E07001E0C001E0C001E0C+BF49*/
/*@\\\0001000011*/
